#include "private_area.hh"
#include<sys/time.h>
#include<stdio.h>
#include <sys/types.h>
#include <unistd.h>

void Usage()
{
  printf("Please provide location in environment variables.\nProvide x co-ordinate in environment variable x.\nProvide y coordinate in environment variable y.");
}


PrivateArea::PrivateArea(int argc, char **argv,int x,int y,int c):SecurityApp(argc,argv,x,y,c)
{
 
}

void PrivateArea::eventDetect(int timeofe)
{
  struct timeval tv;
  events new_event;
  gettimeofday(&tv,NULL);
  if (timeofe-lasteventSeen>2)
    {
      printf("Event occured at %d\n",timeofe);
      if (!have_camera)
	{
	  new_event.size=0;
	  new_event.frame=NULL;
	}
      else
	{
	  printf("Ging to get image\n"); 
	  new_event.size=0;
	  new_event.frame=NULL;
	  /*         char *img = (char *)malloc(camera_object->size);
		     img = camera_object->pullCamera();
		     camera_object->convertTgaToJpg(img);
		     // new_event.frame = (unsigned char *)malloc(camera_object->jpgSize);
		     // new_event.frame = (unsigned char *)malloc(4732);
		     FILE *fp;
		     char fwname[20];
		     sprintf(fwname,"/etc/%d",timeofe);
		     fp=fopen(fwname,"wb");
		     fwrite(camera_object->jpgBuf,1,camera_object->jpgSize,fp);
		     fclose(fp);
		     new_event.size=camera_object->jpgSize;*/
	}
      events_seen.insert(eventMap::value_type(timeofe,new_event));
      lasteventSeen = timeofe;    
    }
}
      
void PrivateArea::run()
{
  char c;
  int fd1;
  fd_set rdfs;
  struct timeval tv,tmv;
  int i,t,status;
  unsigned char *buf;
  socklen_t sl=sizeof(struct sockaddr);
  struct sockaddr_in srecv;
  int eventtime;
  lasteventSeen = 0;
  eventDetect(ts);
  if (have_camera)
    {
  
      /*	char *img = (char *)malloc(camera_object->size);
	img = camera_object->pullCamera();
	camera_object->convertTgaToJpg(img);
	FILE *fp;
	char fwname[20];
        sprintf(fwname,"/imgs/%d",ts-3);
        fp=fopen(fwname,"wb");
	fwrite(camera_object->jpgBuf,1,camera_object->jpgSize,fp);
	fclose(fp);*/

    }
		    
  
  responses_handle = setupResponsePublication();
  setupResponseSubscriptionInterest();
  TimerCallback *sr = new Subscriptionint_refresh(this);
  
  if ((fd1 = open("/dev/link/0/data", O_RDWR | O_NONBLOCK)) < 0)
    {
      printf("Cannot open interface for reading event information.\nPlease ensure smacnicd is running\n");
      exit(-1); //Change
    }
 
 ((DiffusionRouting *)dr_)->addTimer(20000, sr);
 
  while(1)
    {
      FD_ZERO(&rdfs);
      FD_SET(0,&rdfs);
      FD_SET(fd1,&rdfs); 
      tmv.tv_sec = 0;
      tmv.tv_usec = 500;
      status = select(fd1+1, &rdfs, NULL, NULL, &tmv);
      if (status > 0)
	{ 
	  int rf_packet_size,i;
  	  if (FD_ISSET(fd1,&rdfs))             
	    {  
	       int flag = ioctl(fd1, PD_GET_FRONT_SIZE, &rf_packet_size);
	       if (flag != 0)
		  {
		    DiffPrint(DEBUG_ALWAYS, "Cannot determine packet size ! Error Code = %d\n",
			   flag);
		    exit(-1);
		  }
	       rf_packet_size = ntohl(rf_packet_size);

	       buf = (unsigned char *)malloc(rf_packet_size);
	       read(fd1,buf,rf_packet_size);

	       struct link_pkt *hdr;
	       hdr = (struct link_pkt*)buf; 
	       if (hdr->type == 100)
		 {
		   struct timeval tv1;
		   gettimeofday(&tv1,NULL);
		   eventDetect(tv1.tv_sec); }
	     }
	    	    
      else 
	    {

	       gettimeofday(&tv,NULL);
	       fread(&c,1,1,stdin);
	       printf("Initiating at %d\n",tv.tv_sec,lasteventSeen);
	       initiateQuery(lasteventSeen);
	     }
	}
 
    }

}

 
     
void PrivateArea::start()
{
  struct timeval tmv;
  // printf("start called \n");
  eventDetect(ts);
  while(1)
      {
	/*  timersManager_->nextTimerTime(&tmv);
   //   printf("%d\n",tmv.tv_sec);
		if (tmv.tv_sec == 0 && tmv.tv_usec == 0) {
		        
		        timersManager_->executeNextTimer();
			continue;
		}
		else
		if (tmv.tv_sec == MAXVALUE && tmv.tv_usec == 0){
		        // There are no timers in the event queue 
		  //  printf("No timers\n");
		}
		else
		  {
		    sleep(tmv.tv_sec);
		    timersManager_->executeNextTimer();
		    }*/

		  }
		  
	
}

int main(int argc, char **argv,char **env)
{
  PrivateArea *app;
  int t,i,x,y,id,c;
  char *temp; 
  
  temp = getenv("x");
  if (temp == NULL)
    {
      Usage();
      exit(0);
    }
  sscanf(temp,"%d",&x);

  temp = getenv("y");
  if (temp == NULL)
    {
      Usage();
      exit(0);
    }
  sscanf(temp,"%d",&y);

  temp = getenv("c");
  if (temp == NULL)
    {
      c = 0;
    }
  else
    {
      sscanf(temp,"%d",&c);
    }

  temp = getenv("t");
  if (temp != NULL)
    {
      sscanf(temp,"%d",&t);
    }
  else
    t = 0;

  app = new PrivateArea(argc, argv,x,y,c); 
  printf("Out\n");
  app->ts=t;
  app->run();

  return 0;
}

