//
// rmst_source.cc  : RmstSource Class Methods
// authors         : Fred Stann
//
// Copyright (C) 2003 by the University of Southern California
// $Id: security_app.cc,v 1.2 2004/03/14 23:48:43 rajgarhi Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#include "security_app.hh"
#include <unistd.h>
#include<stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/mman.h>
#include <linux/ioctl.h>
#include <linux/ioctl.h>
#include <linux/videodev.h>
#include<sys/ioctl.h>
#include<math.h>
#include<sys/time.h>


NRSimpleAttributeFactory<int> nhops(nhops_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> FIRST_SRCX(FIRST_SRCX_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> FIRST_SRCY(FIRST_SRCY_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<void *> SRCdata( SRCdata_Key,NRAttribute::BLOB_TYPE);
NRSimpleAttributeFactory<int> X( X_Coordinate_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> Y( Y_Coordinate_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> EX( EX_Coordinate_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> EY( EY_Coordinate_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> queryid( Query_Id_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> timestamp( Timestamph_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> SRCX( SrcX_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> SRCY( SrcY_Key,NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> picflag( Picflag_Key,NRAttribute::INT32_TYPE);


typedef struct 
{
  struct jpeg_compress_struct info;
  CameraMaintainer *camobj;
}
appended_compress_info;
GLOBAL(void) init_destination(j_compress_ptr cinfo)
{
  appended_compress_info* dest1 = (appended_compress_info*) cinfo;
  dest1->camobj->jpgBuf=(unsigned char *)malloc(4096);
  dest1->info.dest->next_output_byte = dest1->camobj->jpgBuf;
  dest1->info.dest->free_in_buffer = 4096;
  dest1->camobj->jpgSize=0;
}
GLOBAL(boolean)
 empty_output_buffer (j_compress_ptr cinfo)
{ 
  unsigned char *temp;
  // printf("empty called\n");
appended_compress_info* dest1 = (appended_compress_info*) cinfo;
  
  dest1->camobj->jpgSize+=4096;
  temp=(unsigned char *)malloc(dest1->camobj->jpgSize);
  memcpy(temp,dest1->camobj->jpgBuf,dest1->camobj->jpgSize);
  dest1->camobj->jpgBuf=(unsigned char *)malloc(dest1->camobj->jpgSize+4096);
  memcpy(dest1->camobj->jpgBuf,temp,dest1->camobj->jpgSize);
  dest1->info.dest->next_output_byte = dest1->camobj->jpgBuf+dest1->camobj->jpgSize;
  dest1->info.dest->free_in_buffer= 4096;
  free(temp);
  return true;
 
}
GLOBAL(void) term_destination (j_compress_ptr cinfo)
{ //printf("term called\n");
 appended_compress_info* dest1 = (appended_compress_info*) cinfo;
//  memcpy(jpgBuf+jpgSize,cinfo->dest->buffer,BUFSIZE-cinfo->dest->pub.free_in_buffer);
  dest1->camobj->jpgSize=dest1->camobj->jpgSize+4096-dest1->info.dest->free_in_buffer;
}


GLOBAL(void) jpeg_stdio_dest (j_compress_ptr cinfo, FILE * outfile)
{
  struct jpeg_destination_mgr *dest;

  if (cinfo->dest == NULL) {	
    cinfo->dest = (struct jpeg_destination_mgr *)(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
      			  sizeof(jpeg_destination_mgr));
  }
   
    
  

  dest = cinfo->dest;
  dest->init_destination = init_destination;
   dest->empty_output_buffer = empty_output_buffer;
  dest->term_destination = term_destination;
}
void CameraMaintainer::convertTgaToJpg (char *image)
{

	int y, x, line_width;
	struct jpeg_destination_mgr my;
	
	JSAMPROW row_ptr[1];
	//struct jpeg_compress_struct cjpeg;
	appended_compress_info cjpeg;
	cjpeg.camobj=this;
	struct jpeg_error_mgr jerr;
	char *line;
	int quality=50;
	line = (char *)malloc (width * 3);
	if (!line)
		return;
	cjpeg.info.err = jpeg_std_error(&jerr);
	jpeg_create_compress ((struct jpeg_compress_struct *)&cjpeg);
	cjpeg.info.image_width = width;
	cjpeg.info.image_height= height;
	if (palette == VIDEO_PALETTE_GREY) {
		cjpeg.info.input_components = 1;
		cjpeg.info.in_color_space = JCS_GRAYSCALE;
	//	jpeg_set_colorspace (&cjpeg, JCS_GRAYSCALE);
	} else {
		cjpeg.info.input_components = 3;
		cjpeg.info.in_color_space = JCS_RGB;
	}
	jpeg_set_defaults ((struct jpeg_compress_struct *)&cjpeg);
	jpeg_set_quality ((struct jpeg_compress_struct *)&cjpeg, quality, TRUE);
	cjpeg.info.dct_method = JDCT_FASTEST;
	jpeg_stdio_dest ((struct jpeg_compress_struct *)&cjpeg, NULL);


	jpeg_start_compress ((struct jpeg_compress_struct *)&cjpeg, TRUE);
	row_ptr[0] = (JSAMPROW)line;
	if (palette == VIDEO_PALETTE_GREY) {
		line_width = width;
		for ( y = 0; y < height; y++) {
			row_ptr[0] = (JSAMPROW)image;
			jpeg_write_scanlines ((struct jpeg_compress_struct *)&cjpeg, row_ptr, 1);
			image += line_width;
		}
	} else {
		line_width = width * 3;
		for ( y = 0; y < height; y++) {
			for (x = 0; x < line_width; x+=3) {
				line[x]   = image[x+2];
				line[x+1] = image[x+1];
				line[x+2] = image[x];
			}
			jpeg_write_scanlines ((struct jpeg_compress_struct *)&cjpeg, row_ptr, 1);
			image += line_width;
		}
	}
	jpeg_finish_compress ((struct jpeg_compress_struct *)&cjpeg);
	jpeg_destroy_compress ((struct jpeg_compress_struct *)&cjpeg);
	free (line);

}


bool CameraMaintainer::initCamera()
{
   
    int retVal;
    int size;
    int i,h,w;
    struct video_capability vidCap;
    struct video_mbuf mbufInfo;
    struct video_picture vidInfo;
    struct video_mmap captureData0;
    struct video_mmap captureData1;
    char *frame;
    //    printf("\nin const*************************************************************************\n");
    
	videoFD = open("/dev/video0", O_RDWR);
    if (videoFD == -1){
        printf("Error opening /dev/video0\n");
        return(false)  ;
    }

    retVal = ioctl(videoFD, VIDIOCGCAP, &vidCap);
    if (retVal < 0){
        printf ("Error doing VIDIOCGCAP ioctl; errno = %d\n", errno);
        return(false);
    }

    printf("Query Capability name = %s\n", vidCap.name);
    printf("Query Capability type = %x\n", vidCap.type);
    printf("Query Capability maxwidth = %d\n", vidCap.maxwidth);
    printf("Query Capability maxheight = %d\n", vidCap.maxheight);
    printf("Query Capability minwidth = %d\n", vidCap.minwidth);
    printf("Query Capability minheight = %d\n", vidCap.minheight);
    width=vidCap.maxwidth;
    height=vidCap.maxheight;
    retVal = ioctl(videoFD, VIDIOCGPICT, &vidInfo);
    if (retVal < 0){
        printf ("Error doing VIDIOCGPICT ioctl; errno = %d\n", errno);
	return(false);
    }

    printf("Video info palette = %d\n", vidInfo.palette);
    palette=vidInfo.palette;
    retVal = ioctl(videoFD, VIDIOCGMBUF, &mbufInfo);
    if (retVal < 0){
        printf ("Error doing VIDIOCGMBUF ioctl; errno = %d\n", errno);
        return(false) ;
    }

    printf("mbuf size = %d\n", mbufInfo.size);
    printf("mbuf frames = %d\n", mbufInfo.frames);

    captureData0.format = VIDEO_PALETTE_RGB24;
    captureData0.frame = 0;
    captureData0.height = vidCap.maxheight;
    captureData0.width = vidCap.maxwidth;
    captureData1.format = VIDEO_PALETTE_RGB24;
    captureData1.frame = 1;
    captureData1.height = vidCap.maxheight;
    captureData1.width = vidCap.maxwidth;

    size = captureData0.height * captureData0.width * 3 * 2;
    h=captureData0.height;w=captureData0.width;
    frame = (char *)mmap(0, size, PROT_READ, MAP_SHARED, videoFD, 0);
    if (frame == MAP_FAILED) {
        printf("mmap returned MAP_FAILED!\n");
        return(false) ;
    }

    retVal = ioctl(videoFD, VIDIOCMCAPTURE, &captureData0);
    if (retVal < 0){
        printf ("Error doing VIDIOCCAPTURE ioctl; errno = %d\n", errno);
        return(false);
    }

    for(i=0; i<20; i++){
        retVal = ioctl(videoFD, VIDIOCMCAPTURE, &captureData1);
        if (retVal < 0){
            printf ("Error doing VIDIOCCAPTURE ioctl; errno = %d\n", errno);
            return(false);
        }
        retVal = ioctl(videoFD, VIDIOCSYNC, &captureData0.frame);
        if (retVal < 0){
            printf ("Error doing VIDIOCSYNC ioctl; errno = %d\n", errno);
            return(false);
        }
        retVal = ioctl(videoFD, VIDIOCMCAPTURE, &captureData0);
        if (retVal < 0){
            printf ("Error doing VIDIOCCAPTURE ioctl; errno = %d\n", errno);
            return(false);
        }
        retVal = ioctl(videoFD, VIDIOCSYNC, &captureData1.frame);
        if (retVal < 0){
            printf ("Error doing VIDIOCSYNC ioctl; errno = %d\n", errno);
            return(false);
        }
	}
    return(true);

}
char* CameraMaintainer::pullCamera()
{
    struct video_mmap captureData0;
    struct video_mmap captureData1;
    char *frame;
    int retVal;
    captureData0.format = VIDEO_PALETTE_RGB24;
    captureData0.frame = 0;
    captureData0.height = height;
    captureData0.width = width;
    captureData1.format = VIDEO_PALETTE_RGB24;
    captureData1.frame = 1;
    captureData1.height = height;
    captureData1.width = width;
     frame = (char *)mmap(0, height*width*3*2, PROT_READ, MAP_SHARED, videoFD, 0);
    if (frame == MAP_FAILED) {
        printf("mmap returned MAP_FAILED!\n");
        return NULL;
    }
     retVal = ioctl(videoFD, VIDIOCMCAPTURE, &captureData0);
    if (retVal < 0){
        printf ("Error doing VIDIOCCAPTURE ioctl; errno = %d\n", errno);
        return NULL;
    }

        retVal = ioctl(videoFD, VIDIOCMCAPTURE, &captureData1);
        if (retVal < 0){
            printf ("Error doing VIDIOCCAPTURE ioctl; errno = %d\n", errno);
            return NULL;
        }
        retVal = ioctl(videoFD, VIDIOCSYNC, &captureData0.frame);
        if (retVal < 0){
            printf ("Error doing VIDIOCSYNC ioctl; errno = %d\n", errno);
            return NULL;
        }
        retVal = ioctl(videoFD, VIDIOCMCAPTURE, &captureData0);
        if (retVal < 0){
            printf ("Error doing VIDIOCCAPTURE ioctl; errno = %d\n", errno);
            return NULL;
        }
        retVal = ioctl(videoFD, VIDIOCSYNC, &captureData1.frame);
        if (retVal < 0){
            printf ("Error doing VIDIOCSYNC ioctl; errno = %d\n", errno);
            return NULL;
        }
	return frame;
}
CameraMaintainer::~CameraMaintainer()
{
  close(videoFD);
}
CameraPuller::CameraPuller(CameraMaintainer *app)
{
  cam_obj = app;
}
int CameraPuller::expire()
{
  struct timeval ntime;
  gettimeofday(&ntime,NULL);
    char *img = (char *)malloc(cam_obj->size);
       img = cam_obj->pullCamera();
        cam_obj->convertTgaToJpg(img);
       int fp;
       char fwname[100];
       sprintf(fwname,"/imgs/%d",(int)ntime.tv_sec);
      fp=creat(fwname,S_IRUSR|S_IWUSR|S_IROTH|S_IWOTH);
      write(fp,cam_obj->jpgBuf,cam_obj->jpgSize);
      close(fp);
       return 0;
}

Subscriptionint_refresh::Subscriptionint_refresh(SecurityApp *app)
{
  source_app=app;
}
int Subscriptionint_refresh::expire()
{
  source_app->setupResponseSubscriptionInterest();
  return 0;
}
RmstStart::RmstStart(int t,SecurityApp *app)
{
  src = app;
  timage = t;
}
int RmstStart::expire()
{
  src->sendImage(timage-3);
  delete this;
  return -1;
}
Response_timer::Response_timer(SecurityApp *app,int q1,int x1,int y1,unsigned char *data,int s)
{
  source_app=app;
  q = q1;  
  fx=x1;fy=y1;
  size = s;
  blob = (unsigned char *)malloc(s);
  memcpy(blob,data,s);
  timessent=0;
}
int Response_timer::expire()
{  
//printf("RESEND CALLED\n");
//  printf("In response timer\n");
 timessent++; 
 if (timessent<=3)
 
 {  
source_app->sendResponse(q,fx,fy,blob,size);
//printf("Exiting responsetimer with size = %d\n",size);
 return 0;
 }
 else
   {
      delete this;
     //    printf("Exiting response timer after deletion\n");
     return -1;
   }

}




void RmstSrcReceive::recv(NRAttrVec *data, NR::handle my_handle)
{
  bool eventfound=false;
  struct timeval tv;
  NRSimpleAttribute<int> *nr_class = NULL;
  NRSimpleAttribute<char*> *rmst_target_attr = NULL;
  NRSimpleAttribute<int> *which_query_id =NULL;
  NRSimpleAttribute<char *> *security_message = NULL;
  NRSimpleAttribute<int> *timeinterval;
 NRSimpleAttribute<int> *timeinterval1;
 NRAttrVec response;
 //  printf("ATrr receieved handle %ld\n",my_handle);
  nr_class = NRClassAttr.find(data);

if (nr_class)
  {    
    std::set<int>::iterator location;
    if (nr_class->getVal()==NRAttribute::INTEREST_CLASS)
      {
	which_query_id = queryid.find(data);
	if (which_query_id)
	  { 
	    gettimeofday(&tv,NULL);
	    std::pair<queryMap::const_iterator,bool> p;
	    p=src_->queries_seen.insert(queryMap::value_type(which_query_id->getVal(),false));
            int srcx=src_->unmarshalX((unsigned char *)(SRCdata.find(data)->getVal()));
            int srcy=src_->unmarshalY((unsigned char *)(SRCdata.find(data)->getVal()));
            // fprintf(stdout,
	    //       "Diffusion Log: Time %d.%06d Interest SX %d SY %d X %d Y %d\n",
	    //         tv.tv_sec, tv.tv_usec, srcx,srcy,src_->xcor,src_->ycor);
            //  fflush(NULL);
	    if (p.second)
	      
	      { 
		std::pair<queryHandles::const_iterator,bool> pq;
		handle new_handle = src_->setupResponsePublication();
		pq=src_->query_handles.insert(queryHandles::value_type(which_query_id->getVal(),new_handle));
		src_->processQuery(data);
		
	       std::pair<response_state_info::const_iterator,bool> p1;
	       querySource q1;
	       q1.x = src_->unmarshalX((unsigned char *)SRCdata.find(data)->getVal());
	       q1.y = src_->unmarshalY((unsigned char *)SRCdata.find(data)->getVal());
	       p1=src_->resp_info.insert(response_state_info::value_type(which_query_id->getVal(),q1));
	      }
	    // else
	      //  printf("Duplicate query seen\n");  
	    
	  }
      }
	else //re
       {
	
	 src_->processResponse(data);   
    
    
       }
  }
}

	

void SecurityApp::addtimer(int t,TimerCallback *tc)
{
handle h=((DiffusionRouting *)dr_)->addTimer(t,tc);
	
}




 void  SecurityApp::publishPicAttrs(int t)
    {
      NRAttrVec picattrs;
      //  printf("\npublishing attrs for pic %d %d %d\n",xcor,ycor,t);
      //        picattrs.push_back(RmstTsprtCtlAttr.make(NRAttribute::IS, RMST_RESP));
      picattrs.push_back(NRClassAttr.make(NRAttribute::IS,NRAttribute::DATA_CLASS));
      //    picattrs.push_back(SecurityMessageType.make(NRAttribute::IS,"PIC"));
	//  picattrs.push_back(X.make(NRAttribute::IS,xcor));
	//picattrs.push_back(Y.make(NRAttribute::IS,ycor));
       picattrs.push_back(RmstTargetAttr.make(NRAttribute::IS, "PIC"));
      // picattrs.push_back(timestamph.make(NRAttribute::EQ,t));
      handle h=dr_->publish(&picattrs);
      eventMap::iterator iter = events_seen.find(t);
      //  printf("Earlier handle was %ld\n",iter->second.h);
      printf("Earlier size was %d\n",iter->second.size);
      iter->second.h=h;
      events_seen[t]=iter->second;
      printf("\n now handle is %ld\n",events_seen[t].h);
      printf("\n size is %d\n",events_seen[t].size);
      ClearAttrs(&picattrs);
    }
 
SecurityApp::SecurityApp(int argc, char **argv,int x,int y,int c)
{
  camera_object=new CameraMaintainer();
  if (c==1) 
     have_camera=camera_object->initCamera(); 
  
  int status;
  socklen_t staddress = sizeof(struct sockaddr);
  
  xcor=x;
  ycor=y;
  
  fsrc=false;
  mr = new RmstSrcReceive(this);
  parseCommandLine(argc, argv);
  dr_ = NR::createNR(diffusion_port_);
  no=2*y+x;
  no_query=0;
  lasteventSeen = 0;
  
  if (c==1) 
    { 
      printf("Setting up publication\n");
      have_camera = true; 
      setupImagePublication();
      struct timeval tchk;
      gettimeofday(&tchk,NULL);
      printf("Starting at %d\n",tchk);
      CameraPuller *cp = new CameraPuller(camera_object);
      ((DiffusionRouting *)dr_)->addTimer(1000,cp);
    }
  else 
    have_camera=false;

} 

void SecurityApp::setupImagePublication()
{
  NRAttrVec rmstpub;
  rmstpub.push_back(NRClassAttr.make(NRAttribute::IS, NRAttribute::DATA_CLASS));
  rmstpub.push_back(RmstTargetAttr.make(NRAttribute::IS, "PCM_SAMPLE"));
  rmstpub.push_back(NRAlgorithmAttr.make(NRAttribute::IS,NRAttribute::TWO_PHASE_PULL_ALGORITHM));
  imagepub=dr_->publish(&rmstpub);
  ClearAttrs(&rmstpub);
}

void SecurityApp::sendImage(int t)
{
  NRAttrVec imagedata;
  FILE *fp;
  char fname[100];
  do
    {
     sprintf(fname,"/imgs/%d",t);
     fp = fopen(fname,"r");
     if (fp!=NULL)
       {

        fseek(fp,0,SEEK_END);
        long int fsize = ftell(fp);
        rewind(fp);
        printf("\n\tSENDING IMAGE of size %ld\n",fsize);
        unsigned char *imgdata;
        imgdata = (unsigned char *)malloc(fsize);
        fread(imgdata,fsize,1,fp);
        fclose(fp);
        imagedata.push_back(RmstDataAttr.make(NRAttribute::IS,imgdata,fsize));
        int retval=((DiffusionRouting *)dr_)->sendRmst(imagepub,&imagedata,200);
	return;
       }
     t-- ;
    }
  while(1);
}
void SecurityApp::run()
{
  
  setupResponseSubscriptionInterest();
  responses_handle = setupResponsePublication();
  while(1)
    {
  
    sleep(10);

    }
}
void SecurityApp::setupResponseSubscriptionInterest()
{
  NRAttrVec attrs;
  dr_->unsubscribe(subscription_interest_handle_);
  attrs.push_back(NRClassAttr.make(NRAttribute::EQ,NRAttribute::INTEREST_CLASS));
  attrs.push_back(X.make(NRAttribute::IS,xcor));
  attrs.push_back(Y.make(NRAttribute::IS,ycor));
  attrs.push_back(NRAlgorithmAttr.make(NRAttribute::IS,NRAttribute::ONE_PHASE_PULL_ALGORITHM));
  attrs.push_back(NRScopeAttr.make(NRAttribute::IS,NRAttribute::NODE_LOCAL_SCOPE));
  subscription_interest_handle_=dr_->subscribe(&attrs,mr);
  // printf("THE LOCAL HANDLE IS %d\n",h);
  ClearAttrs(&attrs);
}


void SecurityApp::setupResponseSubscription(int t,int qid,int hop_count)
{
  NRAttrVec attrs;
  int id;
  unsigned char srcdata[12];
  // printf("Resp sub called\n");
  // printf("publishing respone interest %d\n\n",qid);
  attrs.push_back(NRClassAttr.make(NRAttribute::IS,NRAttribute::INTEREST_CLASS));
  attrs.push_back(NRAlgorithmAttr.make(NRAttribute::IS,NRAttribute::ONE_PHASE_PULL_ALGORITHM));
  attrs.push_back(queryid.make(NRAttribute::IS,qid));
  attrs.push_back(EX.make(NRAttribute::IS,xcor));
  attrs.push_back(EY.make(NRAttribute::IS,ycor));
  attrs.push_back(X.make(NRAttribute::LE,xcor+1));
  attrs.push_back(X.make(NRAttribute::GE,xcor-1));
  attrs.push_back(Y.make(NRAttribute::LE,ycor+1));
  attrs.push_back(Y.make(NRAttribute::GE,ycor-1));
  attrs.push_back(nhops.make(NRAttribute::IS,hop_count));
  //  attrs.push_back(SRCX.make(NRAttribute::IS,xcor));
  // attrs.push_back(SRCY.make(NRAttribute::IS,ycor));
  marshal(xcor,ycor,t,srcdata);
  attrs.push_back(SRCdata.make(NRAttribute::IS,srcdata,12));
  handle h=dr_->subscribe(&attrs,mr);
  ClearAttrs(&attrs);
 struct timeval tv;
 gettimeofday(&tv,NULL);
 // fprintf(stdout,
 //	    "Diffusion Log: Time %d.%06d Node %d sending unicast %d bytes to node %d message %s\n",
 //	    tv.tv_sec, tv.tv_usec, id, 100, 2, "Interest");
  fflush(NULL);

}
handle SecurityApp::setupResponsePublication()
{
  NRAttrVec attrs;
  attrs.push_back(NRClassAttr.make(NRAttribute::IS,NRAttribute::DATA_CLASS));
  attrs.push_back(NRAlgorithmAttr.make(NRAttribute::IS,NRAttribute::ONE_PHASE_PULL_ALGORITHM)); 
 handle h1 = dr_->publish(&attrs);
  ClearAttrs(&attrs);
  return h1;
}


void SecurityApp::initiateQuery(int t1)
{
  int id;
  NRAttrVec attrs;
  struct timeval tv;
 int queryid1 = no*256*256+no_query;
 no_query++;
 fsrc=true;
 
 std::pair<queryMap::const_iterator,bool> p;
	    p=queries_seen.insert(queryMap::value_type(queryid1,true));
	    setupResponseSubscription(t1,queryid1,0);
	    gettimeofday(&tv,NULL);
 
 fflush(NULL);
}
void SecurityApp::eventDetect(int te)
{
}
/*void SecurityApp::processQuery(NRAttrVec* data)
{
  int d,srcx,srcy,targettime;
  RmstStart *rm; 
  int hop_count;
  struct timeval tv;
  unsigned char ourResponse[2500];
  int currsize = 0;
  memcpy(ourResponse+currsize,&xcor,sizeof(int));
  memcpy(ourResponse+sizeof(int),&ycor,sizeof(int));
  currsize = 2*sizeof(int);
  gettimeofday(&tv,NULL);
  bool eventfound=false;
  srcx=unmarshalX((unsigned char *)(SRCdata.find(data)->getVal()));
  srcy=unmarshalY((unsigned char *)(SRCdata.find(data)->getVal()));
  hop_count = nhops.find(data)->getVal()+1;
  //fprintf(stdout,
  //           "Diffusion Log: Time %d.%06d Interest SX %d SY %d X %d Y %d\n",
  //             tv.tv_sec, tv.tv_usec, srcx,srcy,xcor,ycor);
  //          fflush(NULL);

  printf("Recv Query from\n");
  printf("\t X = %d\n",srcx);
  printf("\t Y = %d\n",srcy);
  d=(int)sqrt((srcx-xcor)*(srcx-xcor)+(srcy-ycor)*(srcy-ycor));
  targettime=unmarshalT((unsigned char *)(SRCdata.find(data)->getVal()))-(d*4)/5;
  NRSimpleAttribute<int> *which_query_id=NULL;
  which_query_id = queryid.find(data);
  int max = 0;
	for(eventMap::const_iterator iter = events_seen.begin();iter!=events_seen.end();iter++)
	  {
		  if (iter->first>=targettime-3 && iter->first<=targettime+3)
		    {
		    		    eventfound=true;
                                    if (iter->first>max)
				      max = iter->first;
		    }
				    
				    

		    
	  }
	if (!eventfound)
	  { 
	    int tempt = -1;
	    memcpy(ourResponse + currsize , &tempt, sizeof(int));
	    currsize = 3* sizeof(int);
            sendResponse(queryid.find(data)->getVal(),srcx,srcy,ourResponse,currsize);
  	    fprintf(stdout,
  	            "Diffusion Log: Time %d.%06d Indication SX %d SY %d N\n",
  	              tv.tv_sec, tv.tv_usec, xcor,ycor);
            fflush(NULL);
	
	  }
	  
else
{
  memcpy(ourResponse+currsize,&max,sizeof(int));
  currsize = currsize + sizeof(int);
  setupResponseSubscription(max,queryid.find(data)->getVal(),hop_count);
				   
				    if (have_camera) {
				      printf("Adding TIMER FOR IMAGE TRANFER\n");
				      rm = new RmstStart(max,this);
}				      ((DiffusionRouting *)dr_)->addTimer(60000,rm);

  int qid = queryid.find(data)->getVal();
  Response_timer *rt= new Response_timer(this,qid,srcx,srcy,ourResponse,currsize);
  ((DiffusionRouting *)dr_)->addTimer((3-hop_count)*5000, rt);
     responses_seen[qid].respBlob = (unsigned char *)malloc(currsize);
     responses_seen[qid].callback_object = rt;
     memcpy(responses_seen[qid].respBlob, ourResponse,currsize);
     responses_seen[qid].size = currsize;
}
}*/
void SecurityApp::processQuery(NRAttrVec* data)
{
  int d,srcx,srcy,targettime;
   
  int hop_count;
  struct timeval tv;
  unsigned char ourResponse[2500];
  int currsize = 0;
  memcpy(ourResponse+currsize,&xcor,sizeof(int));
  memcpy(ourResponse+sizeof(int),&ycor,sizeof(int));
  currsize = 2*sizeof(int);
  gettimeofday(&tv,NULL);
  bool eventfound=false;
  srcx=unmarshalX((unsigned char *)(SRCdata.find(data)->getVal()));
  srcy=unmarshalY((unsigned char *)(SRCdata.find(data)->getVal()));
  hop_count = nhops.find(data)->getVal()+1;
  //  fprintf(stdout,
  //           "Diffusion Log: Time %d.%06d Interest SX %d SY %d X %d Y %d\n",
  //             tv.tv_sec, tv.tv_usec, srcx,srcy,xcor,ycor);
  //          fflush(NULL);
  printf("Recv Query from\n");
  printf("\t X = %d\n",srcx);
  printf("\t Y = %d\n",srcy);
  d=(int)sqrt((srcx-xcor)*(srcx-xcor)+(srcy-ycor)*(srcy-ycor));
  targettime=unmarshalT((unsigned char *)(SRCdata.find(data)->getVal()))-(d*4)/5;
  NRSimpleAttribute<int> *which_query_id=NULL;
  which_query_id = queryid.find(data);
	for(eventMap::const_iterator iter = events_seen.begin();iter!=events_seen.end();iter++)
	  {
		  if (iter->first>=targettime-3 && iter->first<=targettime+3 &&!eventfound)
		    {
		    		    eventfound=true;
				    memcpy(ourResponse+currsize,&iter->first,sizeof(int));
				    currsize = currsize + sizeof(int);

				    
				    fprintf(stdout,
					    "Diffusion Log: Time %d.%06d Indication SX %d SY %d Y\n",
					    tv.tv_sec, tv.tv_usec, xcor,ycor);
				    fflush(NULL);
				    setupResponseSubscription(iter->first,queryid.find(data)->getVal(),hop_count);
				    //  printf("subscribed\n");
				    if (have_camera) {
				      printf("Adding TIMER FOR IMAGE TRANFER\n");
				      RmstStart *rm = new RmstStart(iter->first,this);
				      //sleep(5);sendImage(iter->first);
				      ((DiffusionRouting *)dr_)->addTimer(60000,rm);
				      
				    }
				    


		    }
	  }
	if (!eventfound)
	  { 
	    int tempt = -1;
	    memcpy(ourResponse + currsize , &tempt, sizeof(int));
	    currsize = 3* sizeof(int);
            sendResponse(queryid.find(data)->getVal(),srcx,srcy,ourResponse,currsize);
  	    fprintf(stdout,
  	            "Diffusion Log: Time %d.%06d Indication SX %d SY %d N\n",
  	              tv.tv_sec, tv.tv_usec, xcor,ycor);
            fflush(NULL);
	
  
	  }
else
{
  int qid = queryid.find(data)->getVal();
  Response_timer *rt= new Response_timer(this,qid,srcx,srcy,ourResponse,currsize);
  ((DiffusionRouting *)dr_)->addTimer((3-hop_count)*4000, rt);
     responses_seen[qid].respBlob = (unsigned char *)malloc(currsize);
     responses_seen[qid].callback_object = rt;
     memcpy(responses_seen[qid].respBlob, ourResponse,currsize);
     responses_seen[qid].size = currsize;
}
}
void SecurityApp::sendResponse(int q,int fx,int fy,unsigned char * blob, int size)
{
  NRAttrVec data;
  data.push_back(SRCdata.make(NRAttribute::IS,blob,size));
  //  printf("Query id is %d\n",q);
  data.push_back(NRAlgorithmAttr.make(NRAttribute::IS,NRAttribute::ONE_PHASE_PULL_ALGORITHM));
  data.push_back(X.make(NRAttribute::IS,fx));    // Add coordinates to match up against the rectangle
  data.push_back(Y.make(NRAttribute::IS,fy));
  data.push_back(EX.make(NRAttribute::EQ,fx));    // Add coordinates for exact match 
  data.push_back(EY.make(NRAttribute::EQ,fy));
  data.push_back(queryid.make(NRAttribute::EQ,q));
  ((DiffusionRouting*) dr_)->send(query_handles[q],&data);
  ClearAttrs(&data);
}
void SecurityApp::marshal(int x ,int y,int t,unsigned char *data)
{
  t = htonl(t);
  y = htonl(y);
  x = htonl(x);
  memcpy(data,&x,sizeof(int));
  memcpy(data+sizeof(int),&y,sizeof(int));
  memcpy(data+2*sizeof(int),&t,sizeof(int));
}
int SecurityApp::unmarshalX(unsigned char *data)
{
  int x;
  memcpy(&x,data,sizeof(int));
  return(ntohl(x));
}
int SecurityApp::unmarshalY(unsigned char *data)
{
  int y;
  memcpy(&y,data+sizeof(int),sizeof(int));
  return(ntohl(y));
}
int SecurityApp::unmarshalT(unsigned char *data)
{
  int t;
  memcpy(&t,data+2*sizeof(int),sizeof(int));
  return(ntohl(t));
}
void SecurityApp::processResponse(NRAttrVec *data)
{
 int qid;
 int first_response;
 bool dupResponse;
 // printf("In process response\n");
 int size_of_recv_blob,size_of_our_blob,i,srcx,srcy;
 unsigned char *our_data_blob,*new_data_blob;
 new_data_blob = (unsigned char *)SRCdata.find(data)->getVal();
size_of_recv_blob = SRCdata.find(data)->getLen();

	 
 qid = queryid.find(data)->getVal();

 our_data_blob = responses_seen[qid].respBlob;
 size_of_our_blob = responses_seen[qid].size;
  for(i=0;i<size_of_recv_blob;i = i+3*sizeof(int))
       {
	 int temp;
	 memcpy(&temp,new_data_blob+i,sizeof(int));
	 printf("\t\tX=%d\n",temp);
	 memcpy(&temp,new_data_blob+i+sizeof(int),sizeof(int));
	 printf("\t\tY=%d\n",temp);
	  memcpy(&temp,new_data_blob+i+2*sizeof(int),sizeof(int));
	 printf("\t\tt=%d\n",temp);
	 printf("\n");
       }
 if (!queries_seen[qid])
   {
 if (size_of_recv_blob < 3*sizeof(int))
   {
     perror("Wrong response size\n");
     exit(0);
   }
 if (size_of_recv_blob == 3*sizeof(int))
   {
     memcpy(&first_response,new_data_blob+2*sizeof(int),sizeof(int));
     if (first_response == -1)
       return;
   }

 dupResponse = true;
 for(i=0;i<size_of_recv_blob;i = i+3*sizeof(int))
   if (!exists(our_data_blob,size_of_our_blob,new_data_blob+i))
     {
       dupResponse = false;
     }
 if (!dupResponse)
   {
     (responses_seen[qid].callback_object)->blob = (unsigned char *)malloc(size_of_our_blob+size_of_recv_blob);
     memcpy((responses_seen[qid].callback_object)->blob, our_data_blob,size_of_our_blob);
     memcpy((responses_seen[qid].callback_object)->blob + size_of_our_blob, new_data_blob,size_of_recv_blob);
     (responses_seen[qid].callback_object)->size = size_of_our_blob+size_of_recv_blob;
     responses_seen[qid].respBlob = (unsigned char *)malloc(size_of_our_blob+size_of_recv_blob);
     memcpy(responses_seen[qid].respBlob, our_data_blob,size_of_our_blob);
     memcpy(responses_seen[qid].respBlob + size_of_our_blob, new_data_blob,size_of_recv_blob);
     responses_seen[qid].size = size_of_our_blob+size_of_recv_blob;
     (responses_seen[qid].callback_object)->timessent = 0; 
    //printf("Data strcut blob set\n");
    memcpy(&srcx,new_data_blob,4);
    memcpy(&srcy,new_data_blob+4,4);
    struct timeval tv;
    gettimeofday(&tv,NULL);
 //fprintf(stdout,
	//           "Diffusion Log: Time %d.%06d Data SX %d SY %d X %d Y %d\n",
	  //           tv.tv_sec, tv.tv_usec, srcx,srcy,xcor,ycor);
            //  fflush(NULL);
     
   }

   
 //  else
 //  {
//    printf("DUPLICATE RESPONSE\n");
 //  }
   }
 // printf("Exiting process response");
}
bool SecurityApp::exists(unsigned char *src, int size,unsigned char * wtl)
{
  int i, j;
  bool found = false;
//  printf("EXisis eneterd\n");
  for(i=0;i<size;i = i+3*sizeof(int))
    {
      found = true;
      for(j = i;j < i + 3 * sizeof(int) ; j++)
         if (src[j] != wtl[j-i])
	   {
	     found = false;
	   }
      if (found) return true;
    }
//  printf("Exists exiting\n");
  return false;
}
	
       
 
