//
// rmst_source.cc  : RmstSource Class Methods
// authors         : Fred Stann
//
// Copyright (C) 2003 by the University of Southern California
// $Id: sink.cc,v 1.2 2004/03/14 23:48:43 rajgarhi Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#include "sink.hh"
#include <unistd.h>
#include<stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/mman.h>


void SinkReceive::recv(NRAttrVec *data, NR::handle my_handle)
{
  printf("Data receieved of size %d\n",RmstDataAttr.find(data)->getLen());
  FILE *fp;
  fp = fopen("/imgr/recv.jpg","wb");
  fwrite(RmstDataAttr.find(data)->getVal(),RmstDataAttr.find(data)->getLen(),1,fp);
  fclose(fp);
}

Sink::Sink(int argc, char **argv,int x,int y)
{ 
  //  xcor=x;
  // ycor=y;
  mr = new SinkReceive(this);
  parseCommandLine(argc, argv);
  dr_ = NR::createNR(diffusion_port_);
  no=2*y+x;
}

void Sink::getPic(int x,int y,int ts)
{
  NRAttrVec picattrs;
  printf("getting pic %d %d %d\n",x,y,ts);
  picattrs.push_back(NRClassAttr.make(NRAttribute::IS,NRAttribute::INTEREST_CLASS));
  //   picattrs.push_back(SecurityMessageType.make(NRAttribute::EQ,"PIC"));
    // picattrs.push_back(X.make(NRAttribute::EQ,x));
    //picattrs.push_back(Y.make(NRAttribute::EQ,y));
  picattrs.push_back(RmstTargetAttr.make(NRAttribute::EQ, "PIC"));
  // picattrs.push_back(timestamph.make(NRAttribute::IS,ts));
  // picattrs.push_back(RmstTsprtCtlAttr.make(NRAttribute::EQ, RMST_RESP));
  int hand = ((DiffusionRouting *)dr_)->subscribe(&picattrs,mr);
ClearAttrs(&picattrs);
}

void Sink::run()
{
  
  responses_interest_handle = setupResponsesInterest();
  while(1)
    {
  
    sleep(10);

    }
}






handle Sink::setupResponsesInterest()
{
  NRAttrVec attrs1;
  
  attrs1.push_back(NRClassAttr.make(NRAttribute::IS, NRAttribute::INTEREST_CLASS));
  attrs1.push_back(NRAlgorithmAttr.make(NRAttribute::IS,NRAttribute::TWO_PHASE_PULL_ALGORITHM));
 attrs1.push_back(RmstTsprtCtlAttr.make(NRAttribute::EQ, RMST_RESP));
  attrs1.push_back(RmstTargetAttr.make(NRAttribute::EQ,"PCM_SAMPLE"));
  //  attrs1.push_back(NRScopeAttr.make(NRAttribute::IS,NRAttribute::NODE_LOCAL_SCOPE));
  handle h1=dr_->subscribe(&attrs1,mr);
  ClearAttrs(&attrs1);
  return h1;
}

int main(int argc, char **argv,char **env)
{
  Sink *app;
  int i,x,y,id;
  for(i=0;env[i]!=0;i++)
   if (strncmp("node_addr=",env[i],10)==0)
     sscanf(env[i]+10,"%d",&id);
  x = id %2;
  y = id / 2;
  app = new Sink(argc, argv,x,y); 
  app->run();

  return 0;
}
