
//
// rmst_source.hh  : RmstSource Class
// authors         : Fred Stann
//
// Copyright (C) 2003 by the University of Southern California
// $Id: sink.hh,v 1.2 2004/03/14 23:48:43 rajgarhi Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef RMST_SRC
#define RMST_SRC

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif //HAVE_CONFIG_H
#include<set>
#include<map>
#include<algorithm>
#include "diffapp.hh"
#define PAYLOAD_SIZE 500
class Sink;
class SinkReceive : public NR::Callback {
public:
  SinkReceive(Sink *rmstSrc) {src_ = rmstSrc; }
  void recv(NRAttrVec *data, NR::handle my_handle);
protected:
  Sink *src_;
};

  
class Sink : public DiffApp {
public:
  void getPic(int,int,int);
  Sink(int argc, char **argv,int x,int y);
  virtual ~Sink(){};
  handle setupResponsesInterest();
  void run(); 
  NR* getDr() {return dr_;} 
  void eventDetect();
  handle responses_interest_handle;
protected:
  SinkReceive *mr;
  int xcor,ycor,no;
 };




#endif //RMST_SRC
