//
// ip_tunel.hh     : IP connector Include File
// author          : Clarence Chung
//
// Copyright (C) 2000-2005 by the University of Southern California
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef _IP_CONNECTOR_HH_
#define _IP_CONNECTOR_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "diffapp.hh"

#define DST_IP_ADDR_KEY 3604
#define IP_PKT_KEY      3605
#define IP_PKT_SZ_KEY   3606

#define DEFAULT_MTU 1000
#define DEFAULT_IP  0x0A000000
#define DEFAULT_SUBNET_MASK 0xFFFFFF00

class IpConnectorReceive;
class IpConnectorApp;

//#define SEND_DATA_INTERVAL 5

class IpConnectorApp:public DiffApp
{
public:
  IpConnectorApp (int argc, char **argv);

    virtual ~ IpConnectorApp ()
  {
    // Nothing to do
  };

  void run ();
  void recv (NRAttrVec * data, NR::handle my_handle);

private:
  // NR Specific variables
  IpConnectorReceive * mr_;
  handle subHandle_;
  handle pubHandle_;

  unsigned int node_id_;
  unsigned int myMTU;
  unsigned long int myIP;
  unsigned long int myNetMask;
  int tunfd;
  
  char *input_addr; 

  // IP connector App variables
  NRAttrVec data_attr_;
  NRSimpleAttribute < int >*dstaddrAttr_;
  NRSimpleAttribute < void *>*ippktAttr_;
  NRSimpleAttribute < int >*ippktsizeAttr_;

  handle setupSubscription ();
  handle setupPublication ();

  int tun_alloc (char *dev);

  void usage(char *s);
  void parseCommandLine(int argc, char **argv);
};

class IpConnectorReceive:public
  NR::Callback
{
public:
  IpConnectorReceive (IpConnectorApp * app):
  app_ (app)
  {
  };
  void recv (NRAttrVec * data, NR::handle my_handle);

  IpConnectorApp * app_;
};

#endif // !_IP_CONNECTOR_HH_
